local pipe = {}

function pipe:load()
	self.width = settings.screen.width * 0.08
	self.dwidth = settings.screen.width * 0.08
	self.gap = settings.screen.height * 0.35
	self.speed = settings.screen.width * 0.35

	self.extend = settings.screen.height * 0.5

	self.type = {
		normal = 0.9,
		molly = 0.1
	}

	self.array = {}

	self.spawnRate = 0.3
	self.tick = 1 / self.spawnRate
end

function pipe:spawn()
	local r = math.random()
	local t = 1

	if r < self.type.normal and r > self.type.molly then
		t = 1
	elseif r < self.type.molly then
		t = 2
	end

	if mdmaMode then
		t = 1
	end

	self.array[#self.array + 1] = {
		type = t,
		x = settings.screen.width,
		y1 = math.random(settings.screen.height - self.gap),
		dy1 = 0,
		y2 = 0,
		dy2 = settings.screen.height,
		passed = false,
		speed = self.speed * gameSpeed
	}
	self.array[#self.array].y2 = self.array[#self.array].y1 + self.gap
end

function pipe:update(dt)
	if gameStarted and not gameOver and not gamePaused then
		self.tick = self.tick + dt
		if self.tick > (1 / (self.spawnRate * gameSpeed) ) then
			self:spawn()
			self.tick = 0
		end	
	end

	for i,v in ipairs(self.array) do
		v.dy1 = v.dy1 + (v.y1 - v.dy1) * (smoof * 0.5) * dt
		v.dy2 = v.dy2 + (v.y2 - v.dy2) * (smoof * 0.5) * dt

		if gameStarted and not gameOver and not gamePaused then
			v.x = v.x - v.speed * dt

			if mdmaMode  then
				--v.y1 = v.y1 + ((settings.screen.height * 0.005) * math.sin(v.x * 0.01))
				--v.y2 = v.y2 + ((settings.screen.height * 0.005) * math.sin(v.x * 0.01))

				v.y1 = v.y1 + (settings.screen.height * 0.001) * math.sin(t)
				v.y2 = v.y2 + (settings.screen.height * 0.001) * math.cos(t)
			end

			--removing
			if v.x < -(self.width + self.extend) then
				table.remove(self.array, i)
			end
		end
	end
end

function pipe:draw()
	for i,v in ipairs(self.array) do

		if mdmaMode or v.type == 2 then
		local r, g, b, a = hsl(color3, 255, 126)
			love.graphics.setColor(fmath.normal(r, 0, 255), fmath.normal(g, 0, 255), fmath.normal(b, 0, 255), 1)
		else
			love.graphics.setColor(color.pipe)
		end

		love.graphics.rectangle("fill", v.x, -self.extend, self.width, v.dy1 + self.extend)

		love.graphics.rectangle("fill", v.x , v.dy2, self.width, settings.screen.height - v.dy2 + self.extend)

		--if v.type == 2 then
		--	love.graphics.circle("fill", v.x + (self.width / 2), v.y1 + (self.gap / 2), self.width / 4)
		--	love.graphics.setColor(color.background)
		--	love.graphics.printf("e", v.x, v.y1 + (self.gap / 2) - (font.large:getHeight() / 2), self.width, "center")
		--end
	end
end

return pipe