local square = {}

function square:load()
	self.size = math.max(settings.screen.width * 0.05, settings.screen.height * 0.05)
	self.dsize = 0 
	self.tsize = self.size
	self.x = settings.screen.width * 0.1
	self.y = (settings.screen.height / 2) - (self.size / 2)
	self.yVel = 0
	self.god = false
end

function square:update(dt)
	self.dsize = self.dsize + (self.tsize - self.dsize) * smoof * dt

	if gameStarted and not gameOver and not gamePaused then
		--MDMA
		if mdmaMode then
			--self.tsize = self.size + (settings.screen.height * 0.03) * math.sin(t)
		end

		self.yVel = self.yVel + gravity * dt
		if self.yVel > maxVel then
			self.yVel = maxVel
		end

		self.y = self.y + self.yVel * dt

		--Pipe collision
		for i,v in ipairs(pipe.array) do
			local r1 = {
				x = v.x,
				y = 0,
				w = pipe.width,
				h = v.y1
			}
			local r2 = {
				x = v.x,
				y = v.y2,
				w = pipe.width,
				h = settings.screen.height - v.y2
			}

			if fmath.rect(self.x, self.y, self.dsize, self.dsize, r1.x, r1.y, r1.w, r1.h) or fmath.rect(self.x, self.y, self.dsize, self.dsize, r2.x, r2.y, r2.w, r2.h) then
				--if v.type == 1 then
					gameover()
				--end
			end

			--Score counting
			if self.x > (v.x + pipe.width) then
				if not v.passed then
					gameScore = gameScore + 1
					v.passed = true
					ui:setText("score", gameScore)
					if v.type == 2 then
						takeMolly()
					end
				end
			end 
		end
	end

	--Ground collision
	if self.y > settings.screen.height - self.size then
		self.y = settings.screen.height - self.size
		self.yVel = 0
		gameover()
	end

	--Ceiling collision
	if self.y < 0 then
		self.y = 0
		self.yVel = 0
		gameover()
	end
end

function square:flap()
	if not gameOver then
		self.yVel = -flap
		settings.game.totalFlaps = settings.game.totalFlaps + 1
	end
end

function square:draw()
	if mdmaMode then
		local r, g, b, a = hsl(color2, 255, 126)
		love.graphics.setColor(fmath.normal(r, 0, 255), fmath.normal(g, 0, 255), fmath.normal(b, 0, 255), 1)
	else
		love.graphics.setColor(color.square)
	end

	love.graphics.rectangle("fill", self.x - (self.dsize / 2) + (self.size / 2), self.y - (self.dsize / 2) + (self.size / 2), self.dsize, self.dsize)
	--love.graphics.setColor(0, 1, 0, 1)
	--love.graphics.rectangle("line", self.x, self.y, self.size, self.size)
end

return square